Loading...
Searching...
No Matches
BALL::SimpleDownloader Class Reference

`#include <BALL/SYSTEM/simpleDownloader.h>`

Inheritance diagram for BALL::SimpleDownloader:

## Public Member Functions

| SimpleDownloader (const String &url, unsigned int timeout=UINT_MAX)
| SimpleDownloader (const QUrl &url, unsigned int timeout=UINT_MAX)
int | downloadToBuffer (std::vector< char > &buffer)
int | downloadToFile (const String &path)
int | uploadStringToBuffer (const String &data, std::vector< char > &response)
int | uploadStringToFile (const String &data, const String &response)
int | uploadFileToBuffer (const String &path, std::vector< char > &response)
int | uploadFileToFile (const String &path, const String &response)
void | setTimeout (unsigned int timeout)
void | setURL (const String &url)
void | setURL (const QUrl &url)
const QUrl & | getURL () const

## Detailed Description

This class provides an interface for synchronous downloads. It currently relies on QNetworkAccessManager and thus on the existence of a QCoreApplication object. If no global instance is existing a local application object is created. For this reason you must not use this class in any thread but the main thread if you did not create a QCoreApplication object yourself.

REMARK: this class is considered experimental and its interface can be a subject to redesign.

Definition at line 32 of file simpleDownloader.h.

## Constructor & Destructor Documentation

## SimpleDownloader() [1/2]

BALL::SimpleDownloader::SimpleDownloader | ( | const String & | url,
|  | unsigned int | timeout = UINT_MAX )

## SimpleDownloader() [2/2]

BALL::SimpleDownloader::SimpleDownloader | ( | const QUrl & | url,
|  | unsigned int | timeout = UINT_MAX )

## Member Function Documentation

## downloadToBuffer()

int BALL::SimpleDownloader::downloadToBuffer | ( | std::vector< char > & | buffer | ) |

If the content of the download should be kept in memory you can use this function that stores the received bytes in the provides vector. Any previous content is overwritten.

Parameters

  buffer | The buffer vector to use.

Returns
  Non-zero if an error occurred while downloading

## downloadToFile()

int BALL::SimpleDownloader::downloadToFile | ( | const String & | path | ) |

Download the url and store the contents to a file.

Parameters

  path | The path to the file the content is stored in.

Returns
  Non-zero if an error occurred while downloading

## getURL()

const QUrl & BALL::SimpleDownloader::getURL | ( |  | ) | const

Returns the current URL.

Returns
  The currently set URL

## setTimeout()

void BALL::SimpleDownloader::setTimeout | ( | unsigned int | timeout | ) |

Sets the maximum amount of time a download my take. The time is specified in milliseconds.

Parameters

  timeout | The time in milliseconds.

## setURL() [1/2]

void BALL::SimpleDownloader::setURL | ( | const QUrl & | url | ) |

Sets the url of the download.

Parameters

  url | The URL to download

## setURL() [2/2]

void BALL::SimpleDownloader::setURL | ( | const String & | url | ) |

Sets the url of the download.

Parameters

  url | The URL to download

## uploadFileToBuffer()

int BALL::SimpleDownloader::uploadFileToBuffer | ( | const String & | path,
|  | std::vector< char > & | response )

Upload the passed string to the specified URL and save the response to the specified file

Parameters

  path | the path of the file to upload
  response | the response of the server

Returns
  Non-zero if an error occurred while uploading

## uploadFileToFile()

int BALL::SimpleDownloader::uploadFileToFile | ( | const String & | path,
|  | const String & | response )

Upload the passed string to the specified URL and save the response to the specified file

Parameters

  path | the path of the file to upload
  response | the file the response is saved to

Returns
  Non-zero if an error occurred while uploading

## uploadStringToBuffer()

int BALL::SimpleDownloader::uploadStringToBuffer | ( | const String & | data,
|  | std::vector< char > & | response )

Upload the passed string to the specified URL and save the response to the specified buffer

Parameters

  data | the string which is uploaded
  response | the response of the server

Returns
  Non-zero if an error occurred while uploading

## uploadStringToFile()

int BALL::SimpleDownloader::uploadStringToFile | ( | const String & | data,
|  | const String & | response )

Upload the passed string to the specified URL and save the response to the specified file

Parameters

  data | the string which is uploaded
  response | the file the response is saved to

Returns
  Non-zero if an error occurred while uploading